curl --request POST \
--url https://developer.synq.io/api/entities/activity/v1alpha/actor-list \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"selection": {
"publicQuery": {
"parts": [
{
"entityIds": {
"entityIds": [
"<string>"
]
}
}
]
}
},
"kinds": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
'import requests
url = "https://developer.synq.io/api/entities/activity/v1alpha/actor-list"
payload = {
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"selection": { "publicQuery": { "parts": [{ "entityIds": { "entityIds": ["<string>"] } }] } },
"kinds": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
until: '2023-01-15T01:30:15.01Z',
windowDays: 91,
selection: {publicQuery: {parts: [{entityIds: {entityIds: ['<string>']}}]}},
kinds: [],
pagination: {cursor: '<string>', pageSize: 1}
})
};
fetch('https://developer.synq.io/api/entities/activity/v1alpha/actor-list', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://developer.synq.io/api/entities/activity/v1alpha/actor-list",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'until' => '2023-01-15T01:30:15.01Z',
'windowDays' => 91,
'selection' => [
'publicQuery' => [
'parts' => [
[
'entityIds' => [
'entityIds' => [
'<string>'
]
]
]
]
]
],
'kinds' => [
],
'pagination' => [
'cursor' => '<string>',
'pageSize' => 1
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://developer.synq.io/api/entities/activity/v1alpha/actor-list"
payload := strings.NewReader("{\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"selection\": {\n \"publicQuery\": {\n \"parts\": [\n {\n \"entityIds\": {\n \"entityIds\": [\n \"<string>\"\n ]\n }\n }\n ]\n }\n },\n \"kinds\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://developer.synq.io/api/entities/activity/v1alpha/actor-list")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"selection\": {\n \"publicQuery\": {\n \"parts\": [\n {\n \"entityIds\": {\n \"entityIds\": [\n \"<string>\"\n ]\n }\n }\n ]\n }\n },\n \"kinds\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://developer.synq.io/api/entities/activity/v1alpha/actor-list")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"selection\": {\n \"publicQuery\": {\n \"parts\": [\n {\n \"entityIds\": {\n \"entityIds\": [\n \"<string>\"\n ]\n }\n }\n ]\n }\n },\n \"kinds\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}"
response = http.request(request)
puts response.read_body{
"actors": [
{
"kind": "ACTOR_KIND_UNSPECIFIED",
"actor": {
"coalesce": "true"
},
"builtIn": true,
"entityId": "<string>",
"logins": 123,
"totals": {
"queries": 123,
"weights": [
{
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"computeUnit": "COMPUTE_UNIT_UNSPECIFIED",
"weights": {
"executionMs": "<unknown>",
"computeMs": "<unknown>",
"bytesScanned": "<unknown>",
"bytesBilled": "<unknown>"
}
}
],
"reads": 123,
"inputs": 123,
"writes": 123,
"runs": 123,
"entitiesRead": 123,
"entitiesWritten": 123,
"activeDays": 123,
"outsideEntities": {
"executionMs": 123,
"computeMs": 123,
"bytesScanned": 123,
"bytesBilled": 123
}
},
"shares": [
{
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"computeUnit": "COMPUTE_UNIT_UNSPECIFIED",
"shares": {
"executionMs": 123,
"computeMs": 123,
"bytesScanned": 123,
"bytesBilled": 123
}
}
],
"issuers": [
{
"issuer": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"count": 123
}
],
"computeFraction": 123
}
],
"from": "2023-01-15T01:30:15.01Z",
"to": "2023-01-15T01:30:15.01Z",
"pageInfo": {
"totalCount": 123,
"count": 123,
"lastId": "<string>"
},
"peopleHidden": true
}ListActors
List the workspace’s actors, the service accounts, tools, people, logins nothing classifies and Coalesce Quality, each with the totals GetActorSummary has for it: its queries and their weights, its reads, inputs and writes, and the entities it read and wrote. A login can be in several actors, such as its service account and the tool that issued its queries, so the actors never add up to the workspace: GetActivityOverview is the split that does. Only a caller holding the platform users scope sees people and logins: any other gets the rest with people_hidden set.
curl --request POST \
--url https://developer.synq.io/api/entities/activity/v1alpha/actor-list \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"selection": {
"publicQuery": {
"parts": [
{
"entityIds": {
"entityIds": [
"<string>"
]
}
}
]
}
},
"kinds": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
'import requests
url = "https://developer.synq.io/api/entities/activity/v1alpha/actor-list"
payload = {
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"selection": { "publicQuery": { "parts": [{ "entityIds": { "entityIds": ["<string>"] } }] } },
"kinds": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
until: '2023-01-15T01:30:15.01Z',
windowDays: 91,
selection: {publicQuery: {parts: [{entityIds: {entityIds: ['<string>']}}]}},
kinds: [],
pagination: {cursor: '<string>', pageSize: 1}
})
};
fetch('https://developer.synq.io/api/entities/activity/v1alpha/actor-list', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://developer.synq.io/api/entities/activity/v1alpha/actor-list",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'until' => '2023-01-15T01:30:15.01Z',
'windowDays' => 91,
'selection' => [
'publicQuery' => [
'parts' => [
[
'entityIds' => [
'entityIds' => [
'<string>'
]
]
]
]
]
],
'kinds' => [
],
'pagination' => [
'cursor' => '<string>',
'pageSize' => 1
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://developer.synq.io/api/entities/activity/v1alpha/actor-list"
payload := strings.NewReader("{\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"selection\": {\n \"publicQuery\": {\n \"parts\": [\n {\n \"entityIds\": {\n \"entityIds\": [\n \"<string>\"\n ]\n }\n }\n ]\n }\n },\n \"kinds\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://developer.synq.io/api/entities/activity/v1alpha/actor-list")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"selection\": {\n \"publicQuery\": {\n \"parts\": [\n {\n \"entityIds\": {\n \"entityIds\": [\n \"<string>\"\n ]\n }\n }\n ]\n }\n },\n \"kinds\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://developer.synq.io/api/entities/activity/v1alpha/actor-list")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"selection\": {\n \"publicQuery\": {\n \"parts\": [\n {\n \"entityIds\": {\n \"entityIds\": [\n \"<string>\"\n ]\n }\n }\n ]\n }\n },\n \"kinds\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}"
response = http.request(request)
puts response.read_body{
"actors": [
{
"kind": "ACTOR_KIND_UNSPECIFIED",
"actor": {
"coalesce": "true"
},
"builtIn": true,
"entityId": "<string>",
"logins": 123,
"totals": {
"queries": 123,
"weights": [
{
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"computeUnit": "COMPUTE_UNIT_UNSPECIFIED",
"weights": {
"executionMs": "<unknown>",
"computeMs": "<unknown>",
"bytesScanned": "<unknown>",
"bytesBilled": "<unknown>"
}
}
],
"reads": 123,
"inputs": 123,
"writes": 123,
"runs": 123,
"entitiesRead": 123,
"entitiesWritten": 123,
"activeDays": 123,
"outsideEntities": {
"executionMs": 123,
"computeMs": 123,
"bytesScanned": 123,
"bytesBilled": 123
}
},
"shares": [
{
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"computeUnit": "COMPUTE_UNIT_UNSPECIFIED",
"shares": {
"executionMs": 123,
"computeMs": 123,
"bytesScanned": 123,
"bytesBilled": 123
}
}
],
"issuers": [
{
"issuer": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"count": 123
}
],
"computeFraction": 123
}
],
"from": "2023-01-15T01:30:15.01Z",
"to": "2023-01-15T01:30:15.01Z",
"pageInfo": {
"totalCount": 123,
"count": 123,
"lastId": "<string>"
},
"peopleHidden": true
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Body
compute_sort_needs_platform // sorting by compute needs a platform
The window ends at the start of this hour, exclusive. Unset is the current hour.
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"
The window's length in days, back from until. Unset is 30.
x <= 92Only the access to these entities, such as a data product's. Unset is the whole workspace. Under a selection an actor is its access to the selected entities: its reads, inputs and writes and its shares of their cost, with no queries and no weights. A selection of more than 50,000 entities, counting the entities each is the same as, is refused with INVALID_ARGUMENT.
- public_query
- resolver_ql
Show child attributes
Show child attributes
Only actors of these kinds. Empty is every kind the caller may see.
5ActorKind is what an actor of ListActors is.
ACTOR_KIND_UNSPECIFIED, ACTOR_KIND_COALESCE, ACTOR_KIND_SERVICE_ACCOUNT, ACTOR_KIND_TOOL, ACTOR_KIND_PERSON, ACTOR_KIND_LOGIN ActorSort is the order of ListActors, highest first, then by kind and actor.
ACTOR_SORT_UNSPECIFIED, ACTOR_SORT_ACCESS, ACTOR_SORT_QUERIES, ACTOR_SORT_READS, ACTOR_SORT_WRITES, ACTOR_SORT_COMPUTE The platform ACTOR_SORT_COMPUTE sorts on and compute_fraction is of. Required with it.
DATA_PLATFORM_TYPE_UNSPECIFIED, DATA_PLATFORM_TYPE_BIGQUERY, DATA_PLATFORM_TYPE_LOOKER, DATA_PLATFORM_TYPE_DBT, DATA_PLATFORM_TYPE_DBT_CLOUD, DATA_PLATFORM_TYPE_DBT_SELF_HOSTED, DATA_PLATFORM_TYPE_SNOWFLAKE, DATA_PLATFORM_TYPE_GCP, DATA_PLATFORM_TYPE_GIT, DATA_PLATFORM_TYPE_GITHUB, DATA_PLATFORM_TYPE_REDSHIFT, DATA_PLATFORM_TYPE_TABLEAU, DATA_PLATFORM_TYPE_AIRFLOW, DATA_PLATFORM_TYPE_CLICKHOUSE, DATA_PLATFORM_TYPE_POSTGRES, DATA_PLATFORM_TYPE_MYSQL, DATA_PLATFORM_TYPE_DATABRICKS, DATA_PLATFORM_TYPE_SQLMESH, DATA_PLATFORM_TYPE_DUCKDB, DATA_PLATFORM_TYPE_TRINO, DATA_PLATFORM_TYPE_ATLAN, DATA_PLATFORM_TYPE_COALESCE, DATA_PLATFORM_TYPE_CASTORDOC, DATA_PLATFORM_TYPE_FIVETRAN, DATA_PLATFORM_TYPE_DAGSTER, DATA_PLATFORM_TYPE_AIRBYTE, DATA_PLATFORM_TYPE_STITCH, DATA_PLATFORM_TYPE_SNOWPLOW, DATA_PLATFORM_TYPE_POWERBI, DATA_PLATFORM_TYPE_THOUGHTSPOT, DATA_PLATFORM_TYPE_SIGMA, DATA_PLATFORM_TYPE_DOMO, DATA_PLATFORM_TYPE_MSSQL, DATA_PLATFORM_TYPE_ORACLE, DATA_PLATFORM_TYPE_ATHENA, DATA_PLATFORM_TYPE_FABRIC, DATA_PLATFORM_TYPE_DB2, DATA_PLATFORM_TYPE_LOOKER_STUDIO, DATA_PLATFORM_TYPE_HEX, DATA_PLATFORM_TYPE_OMNI, DATA_PLATFORM_TYPE_METABASE, DATA_PLATFORM_TYPE_GOOGLE_SHEETS, DATA_PLATFORM_TYPE_GRAFANA, DATA_PLATFORM_TYPE_STREAMLIT, DATA_PLATFORM_TYPE_ASTRATO, DATA_PLATFORM_TYPE_SNOWFLAKE_CORTEX, DATA_PLATFORM_TYPE_SNOWFLAKE_INTELLIGENCE, DATA_PLATFORM_TYPE_CUBE, DATA_PLATFORM_TYPE_CENSUS, DATA_PLATFORM_TYPE_HIGHTOUCH, DATA_PLATFORM_TYPE_WORKATO, DATA_PLATFORM_TYPE_ESTUARY, DATA_PLATFORM_TYPE_DLT, DATA_PLATFORM_TYPE_TERRAFORM, DATA_PLATFORM_TYPE_HEVO, DATA_PLATFORM_TYPE_DATASTREAM, DATA_PLATFORM_TYPE_SYNQ Without a page size every actor is returned.
Show child attributes
Show child attributes
Response
Success
In the asked order.
Show child attributes
Show child attributes
A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a 24-hour linear smear.
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.
Examples
Example 1: Compute Timestamp from POSIX time().
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX gettimeofday().
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java System.currentTimeMillis().
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java Instant.now().
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
toISOString()
method. In Python, a standard datetime.datetime object can be converted
to this format using
strftime with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"
A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a 24-hour linear smear.
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.
Examples
Example 1: Compute Timestamp from POSIX time().
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX gettimeofday().
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java System.currentTimeMillis().
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java Instant.now().
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
toISOString()
method. In Python, a standard datetime.datetime object can be converted
to this format using
strftime with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"
Show child attributes
Show child attributes
Set when the caller may not see people and logins: no PERSON or LOGIN actor is listed.